export function buildPeer() {
    return new Peer();
}

export function buildPeerCustomHost(id, host) {
    return new Peer(id , {host: host, secure: true});
}

export function GetMetadata(conn) {
    return conn.metadata;
}

export function GetBufferedAmount(conn) {
    return conn.dataChannel.bufferedAmount;
}
export function RegisterEvent(peerElement, event, dotNetObject, callbackMethod, nbParams) {
    switch (nbParams) {
        case 0:
            peerElement.on(event,  () =>  dotNetObject.invokeMethod(callbackMethod));
            break;
        case 1:
            peerElement.on(event,  (p1) =>  dotNetObject.invokeMethod(callbackMethod, p1));
            break;
        case 2:
            peerElement.on(event,  (p1, p2) =>  dotNetObject.invokeMethod(callbackMethod, p1, p2));
            break;
        case 3:
            peerElement.on(event,  (p1, p2, p3) =>  dotNetObject.invokeMethod(callbackMethod, p1, p2, p3));
            break;
        case 4:
            peerElement.on(event,  (p1, p2, p3, p4) =>  dotNetObject.invokeMethod(callbackMethod, p1, p2, p3, p4));
            break;
        default:
            throw new Error('Max 4 parameters supported');
    }
}

export function RegisterEventWithRefParam(peerElement, event, dotNetObject, callbackMethod) {
    peerElement.on(event, async (p1) => {
        let p1Container = DotNet.createJSObjectReference(p1);
        await dotNetObject.invokeMethodAsync(callbackMethod, p1Container);
    });
}

